diff --git a/web/pgadmin/__init__.py b/web/pgadmin/__init__.py
index 1649b2bc..c64245de 100644
--- a/web/pgadmin/__init__.py
+++ b/web/pgadmin/__init__.py
@@ -34,6 +34,8 @@ from pgadmin.utils.session import create_session_interface, pga_unauthorised
 from pgadmin.utils.versioned_template_loader import VersionedTemplateLoader
 from datetime import timedelta
 from pgadmin.setup import get_version, set_version
+from pgadmin.utils.ajax import internal_server_error
+
 
 # If script is running under python3, it will not have the xrange function
 # defined
@@ -662,6 +664,12 @@ def create_app(app_name=None):
             'current_blueprint': current_blueprint
         }
 
+    @app.errorhandler(Exception)
+    def all_exception_handler(e):
+        current_app.logger.error(e)
+        return internal_server_error(errormsg=str(e))
+
+
     ##########################################################################
     # All done!
     ##########################################################################
diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid.js b/web/pgadmin/tools/datagrid/static/js/datagrid.js
index 6de7389f..851d53ff 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid.js
+++ b/web/pgadmin/tools/datagrid/static/js/datagrid.js
@@ -438,8 +438,8 @@ define('pgadmin.datagrid', [
               err.errormsg
             );
           } catch (e) {
-            alertify.alert(
-              e.statusText, gettext('Query Tool Initialize Error')
+            alertify.alert(gettext('Query Tool Initialize Error'),
+              e.statusText
             );
           }
         });
